﻿using System;
using System.Collections.Generic;
using System.Text;

public class PyhtonUtils
{
    public static IEnumerable<T> RangePython<T>(T start, T stop, T step)
    {
        dynamic dStart = start;
        dynamic dStop = stop;
        dynamic dStep = step;

        if (dStep == 0)
            throw new ArgumentException("Parameter step cannot equal zero.");

        if (dStart < dStop && dStep > 0)
        {
            for (var i = dStart; i < dStop; i += dStep)
            {
                yield return i;
            }
        }
        else if (dStart > dStop && dStep < 0)
        {
            for (var i = dStart; i > dStop; i += dStep)
            {
                yield return i;
            }
        }
    }
}
